/* Creation et gestion de menu pour le jeu de Domino en gtk */
/* -------------------------------------------------------- */

/*
   Premiere version: 19/04/2001
   Derniere version: 10/07/2001
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <gtk/gtk.h>
#include "domino.h"
#include "menu.h"
#include "regles.h"

#define Version		"0.3.3"

/* Definition des menu */
/* voir menu.h */

/* info sur les regles du jeu ------------------------------- */
/* voir regles.h */

/* Declarations globales ------------------------------------ */
/* voir domino.h */

/* Fonction maitre! ----------------------------------------- */
int main ( int argc, char *argv[])
{
  GtkWidget *Main_vbox;
  gchar buf[25];

/* init bibliotheque */
  gtk_init( &argc, &argv );

/* Creation des boites diverses */
  Creation_boite_abort_jeu ( );
  Creation_boite_quitte ( );
  Creation_boite_auteur ( );
  Creation_boite_regles ( );
  Creation_boite_config ( );
  Creation_boite_erreur ( );

/* On ajoute une fonction d'attente?  */
  gtk_idle_add ( (GtkFunction)la_ferme, NULL);

/* creation fenetre principale */
  Fenetre = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  sprintf(buf, "Domino (v %s)",Version);
  gtk_window_set_title(GTK_WINDOW(Fenetre), buf);
  gtk_window_set_policy(GTK_WINDOW(Fenetre), FALSE, FALSE, FALSE);
  gtk_signal_connect(GTK_OBJECT(Fenetre), "destroy",
                     (GtkSignalFunc)Quitter, NULL);
  gtk_signal_connect(GTK_OBJECT(Fenetre), "delete_event",
                     (GtkSignalFunc)Quitter, NULL);
  gtk_widget_set_uposition( Fenetre, 20, 20 );
/*
  gtk_widget_set_usize( Fenetre, 300, 300 );
*/
  gtk_widget_show (Fenetre);

/* creation d'une vbox pour la fenetre */
  Main_vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(Fenetre), Main_vbox);

/* on initialise les menus et de la barre d'info */
  Creation_menu (Fenetre, Main_vbox);
  Creation_barre_info ( Fenetre, Main_vbox);

  gtk_widget_show (Main_vbox);
 
  /* creation du plateau de jeu
     on utilise une boite avec frame, qui sera notre plateau,
     puis on va inclure des petites boites accolees dedans
     avec une table.
  */

  Frame = gtk_frame_new(TITREPLATEAU);
  gtk_container_set_border_width (GTK_CONTAINER (Frame), 10);
  gtk_container_add(GTK_CONTAINER(Main_vbox), Frame);
  gtk_widget_show (Frame);


  Plateau = Creation_tableau();
  gtk_container_add (GTK_CONTAINER (Frame), Plateau);
  gtk_widget_show (Plateau);

  /* ############################################################# */
  /* on affiche le tout */
  gtk_widget_show_all (Fenetre);

  /* on passe la main a gtk */
  gtk_main();

  return 0;
}

/* -------------------------------------------------------------------   
                    Definitions des fonctions
   ------------------------------------------------------------------- */

/* Creation (ou redimmensionnement) du tableau qui servira
   pour placer les dominos pendant la partie */
GtkWidget *Creation_tableau( void )
{
  int a, i, j;
  gchar buf[50];
  GtkWidget *image, *Table;

  /* on commence par declarer les cases du plateau */
  a=0;
  for (i = 0; i < Lig; i++)
  {
    for ( j = 0; j < Col ; j++)
    {
/*
      if ( i==0 )
      {
        if ( j==0 )
          sprintf(buf, "./pixmaps/basehg.xpm");
        else if ( j==Col-1 )
          sprintf(buf, "./pixmaps/basehd.xpm");
        else 
          sprintf(buf, "./pixmaps/baseh.xpm");
      }
      else if ( i==Lig-1 )
      {
        if ( j==0 )
          sprintf(buf, "./pixmaps/basebg.xpm");
        else if ( j==Col-1 )
          sprintf(buf, "./pixmaps/basebd.xpm");
        else 
          sprintf(buf, "./pixmaps/baseb.xpm");
      }
      else 
      {
        if ( j==0 )
          sprintf(buf, "./pixmaps/basecg.xpm");
        else if ( j==Col-1 )
          sprintf(buf, "./pixmaps/basecd.xpm");
        else
          sprintf(buf, "./pixmaps/base.xpm");
}
*/
/* teste */
sprintf(buf, "./pixmaps/basex.xpm");
      image = xpm_box( Fenetre, buf );
      gtk_widget_show(image);
      Case_plateau[a] = gtk_event_box_new ();
      sprintf(buf, "%d", a);
      gtk_widget_set_name (Case_plateau[a], buf );
      gtk_signal_connect (GTK_OBJECT (Case_plateau[a]),
                          "button_press_event",
                          (GtkSignalFunc)Bouton_plateau, NULL);
      gtk_container_add (GTK_CONTAINER (Case_plateau[a]), image);
      gtk_widget_show(Case_plateau[a++]);   
    }
  }

  /* Creation du plateau et inclusion de pixmap dedans */
  Table = gtk_table_new(Lig+1, Col+1, FALSE);
  gtk_container_set_border_width (GTK_CONTAINER (Table), 4);

  a=0;
  for (i = 0; i < Lig; i++)
  {
    for ( j = 0 ; j < Col ; j++)
    {
      gtk_table_attach_defaults( GTK_TABLE(Table), Case_plateau[a++],
                        j, j+1, i, i+1);
    }
  }
  return Table;
}

/* Creation des menus */
void Creation_menu (GtkWidget *Fenetre, GtkWidget *Main_vbox )
{
  GtkWidget *BarreMenu;
  GtkItemFactory *item_factory;
  GtkAccelGroup *accel_group;
  gint nitems = sizeof(Menu_item) / sizeof(Menu_item[0]);

  /* groupe des raccourcis clavier */
  accel_group = gtk_accel_group_new();

  /* creation de la fabrique */
  item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel_group);

  /*creation des entrees menu */
  gtk_item_factory_create_items(item_factory, nitems, Menu_item, NULL);
  gtk_window_add_accel_group(GTK_WINDOW(Fenetre), accel_group);

  if (BarreMenu)
  {
    /* recup la barre de menu depuis la fabrique */
    BarreMenu=gtk_item_factory_get_widget(item_factory, "<main>");
  }
  /* on place le menu dans la fenetre principale */
  gtk_box_pack_start(GTK_BOX(Main_vbox), BarreMenu, FALSE, TRUE, 0);
}

/* creation d'une zone de texte (champ d'info) sous la barre de menu */
void Creation_barre_info (GtkWidget *Fenetre, GtkWidget *Main_vbox)
{
  GtkWidget *Hbox_info;
  GtkWidget *Separator;

  Hbox_info = gtk_hbox_new(FALSE, 0);
  Label_info = gtk_label_new (" Vos messages personnels. ");
  gtk_misc_set_alignment (GTK_MISC (Label_info), 0, 0);
  gtk_container_add(GTK_CONTAINER(Hbox_info), Label_info);
  gtk_box_pack_start (GTK_BOX (Main_vbox), Hbox_info, FALSE, TRUE, 1);

  /* et encore deux lignes de seraration */
  Separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (Main_vbox), Separator, FALSE, TRUE, 0);
  Separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (Main_vbox), Separator, FALSE, TRUE, 0);

}

/* Creation de la boite d'arret du jeu */
void Creation_boite_abort_jeu ( void )
{
  GtkWidget *Msg, *Button;

  B_ab_jeu = gtk_dialog_new();
  gtk_window_set_title ( GTK_WINDOW(B_ab_jeu), ARRETDJ);
  gtk_signal_connect (GTK_OBJECT(B_ab_jeu), "delete_event", 
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_signal_connect (GTK_OBJECT(B_ab_jeu), "destroy", 
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_window_set_policy (GTK_WINDOW(B_ab_jeu), FALSE, FALSE, FALSE);

  gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (B_ab_jeu)->vbox), 10);
  gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (B_ab_jeu)->vbox), 10);

  Msg = gtk_label_new (MSG_ABJEU);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (B_ab_jeu)->vbox), Msg);
  gtk_widget_show (Msg);

  Button = gtk_button_new_with_label (OUI);
  gtk_signal_connect (GTK_OBJECT (Button), "clicked",
                      (GtkSignalFunc) Fin_jeu, NULL);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (B_ab_jeu)->action_area), Button);
  gtk_widget_show (Button);

  Button = gtk_button_new_with_label (ANNULE);
  gtk_signal_connect (GTK_OBJECT (Button), "clicked",
                      (GtkSignalFunc) Cache, B_ab_jeu);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (B_ab_jeu)->action_area), Button);
  gtk_widget_show (Button);

}

/* Creation de la boite de fin de programme */
void Creation_boite_quitte ( void )
{
  GtkWidget *Msg, *Button;

  Quit = gtk_dialog_new();
  gtk_window_set_title ( GTK_WINDOW(Quit), FDP);
  gtk_signal_connect (GTK_OBJECT(Quit), "delete_event", 
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_signal_connect (GTK_OBJECT(Quit), "destroy", 
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_window_set_policy (GTK_WINDOW(Quit), FALSE, FALSE, FALSE);

  gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (Quit)->vbox), 10);
  gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (Quit)->vbox), 10);

  Msg = gtk_label_new (MSG_FIN);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Quit)->vbox), Msg);
  gtk_widget_show (Msg);

  Button = gtk_button_new_with_label (OUI);
  gtk_signal_connect (GTK_OBJECT (Button), "clicked",
                      (GtkSignalFunc) gtk_main_quit, Quit);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Quit)->action_area), Button);
  GTK_WIDGET_SET_FLAGS (Button, GTK_CAN_DEFAULT);
  gtk_widget_show (Button);
  Button = gtk_button_new_with_label (REP);
  gtk_signal_connect (GTK_OBJECT (Button), "clicked",
                      (GtkSignalFunc) Cache, Quit);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Quit)->action_area), Button);
  GTK_WIDGET_SET_FLAGS (Button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (Button);
  gtk_widget_show (Button);

}

/* Creation de la boite sur l'auteur */
void Creation_boite_auteur ( void )
{
  GtkWidget *Msg, *Button;

  About = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (About), AUTEUR);
  gtk_signal_connect (GTK_OBJECT (About), "delete_event",
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_signal_connect (GTK_OBJECT (About), "destroy",
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_window_set_policy (GTK_WINDOW (About), FALSE, FALSE, FALSE);

  gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (About)->vbox), 10);
  gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (About)->vbox), 10);

  Msg = gtk_label_new (MSGAUTEUR);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (About)->vbox), Msg);
  gtk_widget_show (Msg);

  Button = gtk_button_new_with_label (OUI);
  gtk_signal_connect (GTK_OBJECT (Button), "clicked",
                      (GtkSignalFunc) Cache, About);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (About)->action_area), Button);
  GTK_WIDGET_SET_FLAGS (Button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (Button);
  gtk_widget_show (Button);

}

/* Creation de la boite des regles du jeu */
void Creation_boite_regles ( void )
{
  GtkWidget *Msg, *Button;

  Help = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (Help), RDJ);
  gtk_signal_connect (GTK_OBJECT (Help), "delete_event",
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_signal_connect (GTK_OBJECT (Help), "destroy",
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_window_set_policy (GTK_WINDOW (Help), FALSE, FALSE, FALSE);
  
  gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (Help)->vbox), 10);
  gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (Help)->vbox), 10);
  
  Msg = gtk_label_new(Texte);
  gtk_label_set_justify(GTK_LABEL(Msg), GTK_JUSTIFY_LEFT);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Help)->vbox), Msg);
  gtk_widget_show(Msg);
  
  Button = gtk_button_new_with_label (OUI);
  gtk_signal_connect (GTK_OBJECT (Button), "clicked",
                      (GtkSignalFunc) Cache, Help);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Help)->action_area), Button);
  GTK_WIDGET_SET_FLAGS (Button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (Button);
  gtk_widget_show (Button);

}

/* Creation de la boite qui contiendra les pieces du joueur */
void Creation_boite_joueur ( void )
{
  GtkWidget *Main_vbox;

  Joueur = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (Joueur), CHEVAL);
  gtk_signal_connect (GTK_OBJECT (Joueur), "delete_event",
                     (GtkSignalFunc)Abort_jeu, NULL);
  gtk_signal_connect (GTK_OBJECT (Joueur), "destroy",
                     (GtkSignalFunc)Abort_jeu, NULL);
  gtk_window_set_policy (GTK_WINDOW (Joueur), FALSE, FALSE, FALSE);
  gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (Joueur)->vbox), 10);
  gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (Joueur)->vbox), 10);

  Main_vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_border_width(GTK_CONTAINER(Main_vbox), 1);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Joueur)->action_area), Main_vbox);
  gtk_widget_show (Main_vbox);

  /* on ne declare que le tableau. On placera des pieces dedans qu'apres */
  /* le tableau sera de 5 lignes de 6 cases */
  Chevalet = gtk_table_new(5, 6, FALSE);
  gtk_container_add (GTK_CONTAINER (Main_vbox), Chevalet);
  gtk_widget_show ( Chevalet );

  gtk_widget_show ( Main_vbox );

}

/* Traitement des entrees de menu */
void Traitement (GtkWidget *w, guint op)
{
  max_timeout=0;
  switch(op)
  {
    case JOUER:
	Init_domino();
	break;
    case CONF:
        if ( timer_ok )
	  gtk_label_set (GTK_LABEL (Label_info), " Voila une pice ");
	break;
    case PIOCHE:
        if ( timer_ok )
        {
	  gtk_label_set (GTK_LABEL (Label_info), " Voila une pice ");
          Pioche ( JOUEUR );
	}
        else
        {
	  gtk_label_set (GTK_LABEL (Label_info), " Pas de pioche possible actuellement.");
	  Boite_erreur(" Pas de pioche possible actuellement.");
	}
        break;
    case SCORES:
	gtk_label_set (GTK_LABEL (Label_info), " Scores ");
	break;
    case HELP:
	gtk_label_set (GTK_LABEL (Label_info), " Aide ");
	break;
  }
}

/* Reaction aux boutons sur le plateau de jeu */
int Bouton_plateau (GtkWidget *w)
{
  char buf[50];
  char name[10];
  GtkWidget *image;
  int val, lig, col;
  max_timeout=0;

  val = atoi (w->name);
  lig = (val/Col);
  col = val-(lig*Col);
  strcpy(name, w->name);

  g_message("bouton sur le plateau: %d, lig=%d - col=%d ", val, lig, col );

  /* on remplace le pixmap */
  /* en premier, il faut detruire l'ancienne event_box, puis la recreer */
  gtk_widget_destroy( Case_plateau[val] );
  Case_plateau[val] = gtk_event_box_new ();

  /* a present, on va creer le nouveau pixmap */
  sprintf(buf, "./pixmaps/%dx%d.xpm", Donne_nbr(6), Donne_nbr(6) );

  image=xpm_box(Fenetre, buf);
  gtk_widget_show(image);   
  /* et on le place dans la case! */
  gtk_container_add (GTK_CONTAINER (Case_plateau[val]), image );
  gtk_widget_set_name (Case_plateau[val], name );
  gtk_signal_connect (GTK_OBJECT (Case_plateau[val]),
                      "button_press_event",
                      (GtkSignalFunc)Bouton_plateau, NULL);
  gtk_widget_show(Case_plateau[val]);   
  gtk_table_attach_defaults( GTK_TABLE(Plateau), Case_plateau[val],
                             col, col+1, lig, lig+1);
  return TRUE;
}

/* Reaction aux boutons sur le chevalet du joeur */
int Bouton_chevalet (GtkWidget *w)
{
  int val, lig, col;
  max_timeout=0;

  val = atoi (w->name);
  lig = (val/6);
  col = val-(lig*6);
  g_message("valeur: [%d|%d] ", tableau[joueur[val]].gauche, tableau[joueur[val]].droit );

  return TRUE;
}

/* Initialisation des variables du programme ---------------------------- */
void Init ( int semance )
{
  int i;

  max_timeout=0;
  if ( !semance )
    srand( (unsigned int) time(0) );
  else
    srand( (unsigned int) semance );

  /* pas de control de valeur de retour. Si c'est NULL, gtk 
     termine automatiquement l'application! */
  tableau=g_malloc0( sizeof(Element)*NUM_PIECE );
  for ( i = 0 ; i < (NUM_PIECE+1) ; i++ )
  {
    joueur[i]=-1;
    ord[i]=-1;
  }
}

/* Fourniture d'un nombre 'aleatoire' ----------------------------------- */
int Donne_nbr ( int max )
{
  return ( rand() % max);
}

/* Quitter le programme? ------------------------------------------------ */
void Quitter ( void )
{
  if ( timer_ok )
  {
    gtk_timeout_remove( timer_fin );
    timer_fin=0;
    gtk_label_set (GTK_LABEL (Label_info), " ... en attente... ");
  }
  gtk_widget_show(Quit);
}

/* Arreter la partie en cours ------------------------------------------- */
void Abort_jeu ( void )
{
  if ( timer_ok )
  {
    gtk_timeout_remove( timer_fin );
    timer_fin=0;
    gtk_label_set (GTK_LABEL (Label_info), " ... en attente... ");
  }
  gtk_widget_show(B_ab_jeu);
}

/* Cacher la boite passee en parametre --------------------------------- */
void Cache (GtkWidget *widget, gpointer Handle )
{
  max_timeout=0;
  gtk_widget_hide ( GTK_WIDGET(Handle) );
  if ( (timer_fin == 0) && (timer_ok) )
  { /* on vient de l'une boite qui a supprimee la fonction de timer, alors
       que celle ci fonctionnait (sinon, elle n'etait pas encore en marche)
       on remet donc un timer en route.
    */
    timer_fin=gtk_timeout_add( intervale, (GtkFunction)delai_d_info, NULL);
    gtk_label_set (GTK_LABEL (Label_info), " reprise du jeu ");
  }
}

/* Info sur l'auteur (MOI!!!!) ------------------------------------------ */
void Auteur ( void )
{
  if ( timer_ok )
  {
    gtk_timeout_remove( timer_fin );
    timer_fin=0;
    gtk_label_set (GTK_LABEL (Label_info), " ... en attente... ");
  }
  max_timeout=0;
  gtk_widget_show(About);
}

/* Les regles du jeu ---------------------------------------------------- */
void Regles ( void )
{
  if ( timer_ok )
  {
    gtk_timeout_remove( timer_fin );
    timer_fin=0;
    gtk_label_set (GTK_LABEL (Label_info), " ... en attente... ");
  }
  max_timeout=0;
  gtk_widget_show(Help);
}

/* La boite des configurations ------------------------------------------ */
void Appel_conf ( void )
{
  if ( timer_ok )
  {
    gtk_timeout_remove( timer_fin );
    timer_fin=0;
    gtk_label_set (GTK_LABEL (Label_info), " ... en attente... ");
  }
  max_timeout=0;
  gtk_widget_show(Configuration);
}

/* La boite du joueur --------------------------------------------------- */
void Boite_joueur ( void )
{
  max_timeout=0;
  gtk_widget_show(Joueur);
}

/* Traitement des touches du clavier ------------------------------------ */
void Event_touches (GtkWidget *Widget, GdkEventKey *Event)
{
/*  g_message("key pressed: type:%s", &Event->type); */
}

/* Initialisation des domino dans le tableau ---------------------------- */
void Init_domino ( void )
{
  int i, j, b;

  /* initialisation du gna */
  Init (0);

  gtk_label_set (GTK_LABEL (Label_info), TRI);

  /* melange des dominos */
  b=0;
  for ( i=0 ; i< 7 ; i++ )
  {
    for ( j=i ; j< 7 ; j++ )
    {
      /* recherche dans le tableau un element pas encore initialise */
      do
      {
        b=Donne_nbr(NUM_PIECE);
      } while ( tableau[b].id != 0 );
      tableau[b].droit = i;
      tableau[b].gauche = j;
      tableau[b++].id = 1;
    }
  }

  /* on en tire 6 pour le chevalet du joueur */
  for ( i=0 ; i<6 ; i++ )
  {
    do
    { /* recherche un element du tableau dont l'id = 1 (encore dans la pioche) */
      b = Donne_nbr(NUM_PIECE);
    } while ( tableau[b].id != 1 );
    tableau[b].id = 3; /* on place le domino dans le chevalet du joueur */
    joueur[i]=b;
  }
 
  /* on cree de toute piece le chevalet du joueur */
  Creation_boite_joueur ( );

  /* on inclus les domino dedans */
  for ( i=0 ; i<6 ; i++ )
  {
    New_domino_joueur ( i );
  }
  /* et on l'ouvre */
  Boite_joueur ();

  /* On ajoute une fonction appelee toutes les 'intervale' millisecondes
     qui delivrera un message dans la barre d'info */
  timer_fin=gtk_timeout_add( intervale, (GtkFunction)delai_d_info, NULL);
  timer_ok=1;

  gtk_label_set (GTK_LABEL (Label_info), " OK, je suis pret. Et vous? ");

}

/*Traitement du timeout pour info dans la barre d'info */
int delai_d_info (GtkWidget *w, guint op)
{
  char buf[100];
  sprintf( buf, " essai toutes les 2 secondes: %d ", Donne_nbr(25) );
  gtk_label_set (GTK_LABEL (Label_info), buf );

  return TRUE;
}

int la_ferme ( GtkWidget *w, guint op)
{
  if ( max_timeout > (20*60*10000) )
    gtk_main_quit (); /* gtk_widget_show(Quit); */
  else
    max_timeout++;
  return TRUE;
}

/* on a demande la fermeture de la boite chevalet */
int Fin_jeu ( void )
{

  max_timeout=0;
  timer_ok=0;

  gtk_widget_hide ( GTK_WIDGET(B_ab_jeu) );
  gtk_widget_hide ( GTK_WIDGET(Joueur) );

  /* on dtruit les cases puis en recr le tableau vide */
  gtk_widget_destroy( Plateau );
  Plateau = Creation_tableau();
  gtk_container_add (GTK_CONTAINER (Frame), Plateau);
  gtk_widget_show (Plateau);

  gtk_label_set (GTK_LABEL (Label_info), " A vos ordres, Chef! ");

  g_free(tableau);

  return TRUE;
}

/* on tire une piece, pour l'ord ou pour le joueur */
void Pioche ( int Qui )
{
  int i, b, a=0;

  if ( Qui== ORD )
  { /* C'est l'ord */
  }
  else if ( Qui == JOUEUR )
  { /* c'est le joueur */
    /* i=la premiere place dispo pour le domino */
    for ( i=0 ; joueur[i] != -1 ; i++ );

    if ( i == NUM_PIECE )
    {
      gtk_label_set (GTK_LABEL (Label_info), " Plus de place dans le chevalet.");
      Boite_erreur (" Plus de place dans le chevalet.");
    }
    else
    {
      gtk_label_set (GTK_LABEL (Label_info), " recherche du premier domino.");
      do
      { /* recherche un element du tableau dont l'id = 1 (encore dans la pioche) */
        b = Donne_nbr(NUM_PIECE);
        a++;
      } while ( (tableau[b].id !=1) || (a == NUM_PIECE) );

      if ( a == NUM_PIECE )
      {
        gtk_label_set (GTK_LABEL (Label_info), " Plus de pice dans la pioche. ");
        Boite_erreur (" Plus de pice dans la pioche. ");
      }
      else
      {
        tableau[b].id = 3; /* on place le domino dans le chevalet du joueur */
        joueur[i]=b;
        New_domino_joueur ( i );
      }
    }
  }
}

/* on va creer le domino et le mettre dans le chevalet */
void New_domino_joueur ( int num_case )
{
  GtkWidget *image;
  int b, co, li;
  char buf[50];

  Case_chevalet[num_case] = gtk_event_box_new ();

  /* a present, on va creer le nouveau pixmap */
  b=joueur[num_case];
  sprintf(buf, "./pixmaps/%dx%d.xpm", tableau[b].gauche, tableau[b].droit);

  image=xpm_box(Fenetre, buf);
  gtk_widget_show(image);   
  /* et on le place dans la case! */
  gtk_container_add (GTK_CONTAINER (Case_chevalet[num_case]), image );
  gtk_container_set_border_width (GTK_CONTAINER (Case_chevalet[num_case]), 2);
  sprintf(buf, "%d", num_case);
  gtk_widget_set_name (Case_chevalet[num_case], buf);
  gtk_signal_connect (GTK_OBJECT (Case_chevalet[num_case]),
                      "button_press_event",
                      (GtkSignalFunc)Bouton_chevalet, NULL);
  gtk_widget_show(Case_chevalet[num_case]); 

  /* calcul de la colonne et de la ligne */
  li = (num_case/6);
  co = num_case - (li*6);
  gtk_table_attach_defaults( GTK_TABLE(Chevalet), Case_chevalet[num_case],
                             co, co+1, li, li+1);
  gtk_widget_show(Chevalet); 
}

/* Creation de la boite de configuration */
void Creation_boite_config ( void )
{
  GtkWidget *B_ok, *B_appli, *B_cancel;
  GtkWidget *Taille, *Box, *Box2, *Box3, *Box_boutons;
  GtkWidget *Label, *Label1;
  GtkAdjustment *Adj, *Adj1;

  Configuration = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (Configuration), TITRE_B_CONF);
  gtk_signal_connect (GTK_OBJECT (Configuration), "delete_event",
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_signal_connect (GTK_OBJECT (Configuration), "destroy",
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_window_set_policy (GTK_WINDOW (Configuration), FALSE, FALSE, FALSE);
  
  gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (Configuration)->vbox), 10);
  gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (Configuration)->vbox), 10);
  
/* ici, se trouverons deux boutons/texte pour la taille du plateau */
  Taille = gtk_frame_new("Taille du plateau de jeu");
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Configuration)->vbox), Taille);
  Box=gtk_hbox_new(FALSE, 5);
  gtk_container_add(GTK_CONTAINER(Taille), Box);
  gtk_widget_show(Box);

/* le spinner des lignes est dans une boite verticale*/
  Box2=gtk_vbox_new(FALSE, 5);
  gtk_box_pack_start(GTK_BOX(Box), Box2, TRUE, TRUE, 5);
  gtk_widget_show(Box2);

  Label=gtk_label_new("Lig");
  gtk_misc_set_alignment (GTK_MISC (Label), 0.5, 0.5);
  gtk_box_pack_start(GTK_BOX(Box2), Label, FALSE, TRUE, 5);
  gtk_widget_show(Label);

  Adj=(GtkAdjustment *)gtk_adjustment_new(Lig, 10, 25, 1, 1, 1);
  Spinli=gtk_spin_button_new(Adj, 0, 0);
/*  gtk_widget_set_usize ( Spinli, 100, 0); */
  gtk_box_pack_start(GTK_BOX(Box2), Spinli, FALSE, TRUE, 1);
  gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(Spinli), TRUE);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON(Spinli), FALSE);
  gtk_widget_show(Spinli);

/* le spinner des colonnes est dans une boite verticale*/
  Box3=gtk_vbox_new(FALSE, 5);
  gtk_box_pack_start(GTK_BOX(Box), Box3, TRUE, TRUE, 5);
  gtk_widget_show(Box3);

  Label1=gtk_label_new("Col");
  gtk_misc_set_alignment (GTK_MISC (Label1), 0.5, 0.5);
  gtk_box_pack_start(GTK_BOX(Box3), Label1, FALSE, TRUE, 5);
  gtk_widget_show(Label1);

  Adj1=(GtkAdjustment *)gtk_adjustment_new(Col, 15, 40, 1, 1, 1);
  Spinco=gtk_spin_button_new(Adj1, 0, 0);
/*  gtk_widget_set_usize ( Spinco, 100, 0); */
  gtk_box_pack_start(GTK_BOX(Box3), Spinco, FALSE, TRUE, 1);
  gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(Spinco), TRUE);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON(Spinco), FALSE);
  gtk_widget_show(Spinco);

  gtk_widget_show(Taille);
  
/* EN DERNIER */
/* on cree une boite qui va englober les 3 bouttons de validations */
  Box_boutons=gtk_hbutton_box_new();
  gtk_container_set_border_width (GTK_CONTAINER (Box_boutons), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (Box_boutons), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (Box_boutons), 10);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (Box_boutons), 85, 20);

  B_ok = gtk_button_new_with_label ("Ok");
  gtk_signal_connect (GTK_OBJECT (B_ok), "clicked",
                      (GtkSignalFunc)Ok_conf, Configuration);
  gtk_container_add (GTK_CONTAINER (Box_boutons), B_ok);
  gtk_widget_show(B_ok);

  B_appli = gtk_button_new_with_label ("Appliquer");
  gtk_signal_connect (GTK_OBJECT (B_appli), "clicked",
                     (GtkSignalFunc)Appli_conf, NULL );
  gtk_container_add (GTK_CONTAINER (Box_boutons), B_appli);
  gtk_widget_show(B_appli);

  B_cancel = gtk_button_new_with_label ("Cancel");
  gtk_signal_connect (GTK_OBJECT (B_cancel), "clicked",
                      (GtkSignalFunc)Cancel_conf, NULL);
  gtk_container_add (GTK_CONTAINER (Box_boutons), B_cancel);
  gtk_widget_show(B_cancel);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (Configuration)->action_area), Box_boutons, TRUE, TRUE, 5);

  gtk_widget_show(Box_boutons);
}

/* On prend les valeurs retournees par les bouttons spinner */
void Appli_conf (GtkWidget *w, guint op)
{
  gint i, j;

  if ( timer_ok == 1 )
  {
    Boite_erreur ("Imposible de modifier la taille pendant une partie.");
  }
  else
  {
    i= gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(Spinli));
    j= gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(Spinco));
    if ( (i != Lig) || (j != Col) )
    {
      Lig=i;
      Col=j;
      /* on commence par detruire le plateau actuel */
/*      gtk_widget_destroy( Plateau ); */
      /* puis on le (re)cree avec les nouveaux parametres */
      g_message("redimmension...");
/*
      Plateau = Creation_tableau();
      gtk_container_add (GTK_CONTAINER (Frame), Plateau);
      gtk_widget_show (Plateau);
*/
      g_message("effectue!");
    }
  }
}

/* On prend les valeurs retournees par les bouttons spinner et on ferme la boite */
void Ok_conf (GtkWidget *w, guint op)
{
  Appli_conf ( Configuration, 0);
  Cache ( 0, Configuration);
}

/* On remet les anciennes valeur de Lig et Col dans les champs spinner */
void Cancel_conf (GtkWidget *w, guint op)
{
  gtk_spin_button_set_value (GTK_SPIN_BUTTON(Spinli), (gfloat)Lig);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON(Spinco), (gfloat)Col);
  Cache ( 0, Configuration);
}

/* Affichage de la Boite d'erreur */
void Boite_erreur ( gchar *texte )
{
  max_timeout=0;
  gtk_label_set (GTK_LABEL (Label_err), texte);
  gtk_widget_show(Erreur);
}

/* Creation d'une boite generique d'erreur */
void Creation_boite_erreur ( void )
{
  GtkWidget *Button;

  Erreur = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (Erreur), AUTEUR);
  gtk_signal_connect (GTK_OBJECT (Erreur), "delete_event",
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_signal_connect (GTK_OBJECT (Erreur), "destroy",
                      (GtkSignalFunc) gtk_widget_hide, NULL);
  gtk_window_set_policy (GTK_WINDOW (Erreur), FALSE, FALSE, FALSE);

  gtk_container_set_border_width (GTK_CONTAINER (GTK_DIALOG (Erreur)->vbox), 10);
  gtk_box_set_spacing (GTK_BOX (GTK_DIALOG (Erreur)->vbox), 10);

  Label_err = gtk_label_new (" ");
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Erreur)->vbox), Label_err);
  gtk_widget_show (Label_err);

  Button = gtk_button_new_with_label (" Ooup's ?! ");
  gtk_signal_connect (GTK_OBJECT (Button), "clicked",
                      (GtkSignalFunc) Cache, Erreur);
  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (Erreur)->action_area), Button);
  GTK_WIDGET_SET_FLAGS (Button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (Button);
  gtk_widget_show (Button);

}
