/* Definitions globales pour domino.c  */
/* ----------------------------------- */

/*
   Premiere version: 29/04/2001
   Derniere version: 15/06/2001
*/

/* nombre de lignes et colonnes du tableau de jeu */
#define LIG_DEF		10
#define COL_DEF		15
#define NUM_PIECE	28

/* Definition de textes pre-ecrits */
#define MSG_FIN		"Abandonner maintenant?"
#define MSG_ABJEU	"Voulez vous vraiment arreter\ncette partie?"
#define MSGAUTEUR	"Domino\n\nCopyright (c) R. Suinot 2001\n\n<rsuinot@free.fr>"
#define OUI		"Oui"
#define REP		"Reprendre"
#define NON		"Non"
#define TRI		"Tri des domino..."
#define ANNULE		"Je me suis tromp"
#define ARRETDJ		"arret du jeu?"
#define FDP		"Fin de programme?"
#define AUTEUR		" propos de l'auteur"
#define RDJ		"Rgles du jeu"
#define CHEVAL		"Votre chevalet"
#define TITREPLATEAU	" Tapis de jeu "
#define TITRE_B_CONF	"Configurations"

#define ORD		0
#define JOUEUR		1

/* Declaration des fonctions -------------------------------- */
GtkWidget	*Creation_tableau	(void);
void		Creation_menu		(GtkWidget *Fenetre, GtkWidget *Main_vbox);
void		Creation_barre_info	(GtkWidget *Fenetre, GtkWidget *Main_vbox);
void		Creation_boite_abort_jeu (void);
void		Creation_boite_quitte	(void);
void		Creation_boite_auteur	(void);
void		Creation_boite_regles	(void);
void		Creation_boite_joueur	(void);
void		Traitement		(GtkWidget *w, guint op);
int		Bouton_plateau		(GtkWidget *w);
int		Bouton_chevalet		(GtkWidget *w);
void		Init			(int);
int 		Donne_nbr		(int);
void		Quitter			(void);
void		Abort_jeu		(void);
void		Cache			(GtkWidget *, gpointer );
void		Auteur			(void);
void		Regles			(void);
void		Appel_conf		(void);
void		Boite_joueur		(void);
void		Event_touches		(GtkWidget *, GdkEventKey *);
void		Init_domino		(void);
GtkWidget	*xpm_box		(GtkWidget *parent, char *xpm_name);
int		delai_d_info		(GtkWidget *w, guint op);
int		la_ferme		(GtkWidget *w, guint op);
int		Fin_jeu			(void);
void		Pioche			(int);
void		New_domino_joueur	(int);
void		Creation_boite_config	(void);
void		Appli_conf		(GtkWidget *w, guint op);
void		Ok_conf			(GtkWidget *w, guint op);
void		Cancel_conf		(GtkWidget *w, guint op);
void		Boite_erreur		(gchar *);
void		Creation_boite_erreur	(void);

/* description du tableau des dominos ----------------------- */
typedef struct _Element {
  int droit; /* nombre cote droit  */
  int gauche;/*   "      "  gauche */
  int id; /* indique si domino deja tire, lors du melange
             pendant le jeu: id=0 domino pose sur le plateau
                             id=1    "   dans la pioche
                             id=2    "     "  le chevalet de l'ord
                             id=3    "     "  "      "    du joueur
          */
} Element;


/* Declarations globales ------------------------------------ */

/* les widget de la fenetre et des boites */
GtkWidget *Fenetre;
GtkWidget *Quit, *About, *Help, *Joueur, *B_ab_jeu, *Configuration, *Erreur;

/* tableaux des jeux */
Element *tableau;

int joueur[NUM_PIECE+1], ord[NUM_PIECE+1];
GtkWidget *Frame, *Plateau;
GtkWidget *Chevalet;
GtkWidget *Case_plateau[LIG_DEF*COL_DEF]; 
GtkWidget *Case_chevalet[NUM_PIECE];
GtkWidget *Spinli, *Spinco;
GtkWidget *Label_info, *Label_err;

guint32 max_timeout=0;
char timer_ok=0;
gint timer_fin=0;
guint32 intervale=2000;
char num_case[COL_DEF*LIG_DEF][6];

gint Lig=LIG_DEF;
gint Col=COL_DEF;

/* end of domino.h */
